// -------------------------------------------------------------
//
// Module: firrc
// Generated by MATLAB(R) 9.0 and the Filter Design HDL Coder 3.0.
// Generated on: 2016-05-24 16:04:08
// -------------------------------------------------------------

// -------------------------------------------------------------
// HDL Code Generation Options:
//
// Name: firrc
// InputDataType: numerictype(1,16,0)
// TargetLanguage: Verilog
// GenerateHDLTestBench: off

// -------------------------------------------------------------
// HDL Implementation    : Fully parallel
// -------------------------------------------------------------
// Filter Settings:
//
// Discrete-Time FIR Multirate Filter (real)
// -----------------------------------------
// Filter Structure      : Direct-Form FIR Polyphase Sample-Rate Converter
// Interpolation Factor  : 125
// Decimation Factor     : 32
// Polyphase Length      : 2
// Filter Length         : 141
// Stable                : Yes
// Linear Phase          : Yes (Type 1)
//
// Arithmetic            : fixed
// Numerator             : s16,17 -> [-2.500000e-01 2.500000e-01)
// -------------------------------------------------------------

`timescale 1 ns / 1 ns

module firrc
               (
                clk,
                clk_enable,
                reset,
                filter_in_mux,
                filter_out_mux,
                ce_in,
                ce_out
                );

  input   clk; 
  input   clk_enable; 
  input   reset; 
  input   [31:0] filter_in_mux; //sfix16
  output  [31:0] filter_out_mux; //sfix33_En17
  output  ce_in; 
  output  ce_out; 

////////////////////////////////////////////////////////////////
//Module Architecture: firrc
////////////////////////////////////////////////////////////////
  // Local Functions
  // Type Definitions
  // Constants
  parameter signed [15:0] coeffphase1_1 = 16'b0000000110100000; //sfix16_En17
  parameter signed [15:0] coeffphase1_2 = 16'b0000000111000101; //sfix16_En17
  parameter signed [15:0] coeffphase2_1 = 16'b1101101110100100; //sfix16_En17
  parameter signed [15:0] coeffphase2_2 = 16'b0000000000110110; //sfix16_En17
  parameter signed [15:0] coeffphase3_1 = 16'b1111110010010110; //sfix16_En17
  parameter signed [15:0] coeffphase3_2 = 16'b1111111010100000; //sfix16_En17
  parameter signed [15:0] coeffphase4_1 = 16'b1111111100001000; //sfix16_En17
  parameter signed [15:0] coeffphase4_2 = 16'b1111110110011000; //sfix16_En17
  parameter signed [15:0] coeffphase5_1 = 16'b0000000001110100; //sfix16_En17
  parameter signed [15:0] coeffphase5_2 = 16'b1111110101111001; //sfix16_En17
  parameter signed [15:0] coeffphase6_1 = 16'b0000000110110000; //sfix16_En17
  parameter signed [15:0] coeffphase6_2 = 16'b1111111001000101; //sfix16_En17
  parameter signed [15:0] coeffphase7_1 = 16'b0000001001010101; //sfix16_En17
  parameter signed [15:0] coeffphase7_2 = 16'b1111111110101000; //sfix16_En17
  parameter signed [15:0] coeffphase8_1 = 16'b0000001000100001; //sfix16_En17
  parameter signed [15:0] coeffphase8_2 = 16'b0000000100011111; //sfix16_En17
  parameter signed [15:0] coeffphase9_1 = 16'b0000000100011111; //sfix16_En17
  parameter signed [15:0] coeffphase9_2 = 16'b0000001000100001; //sfix16_En17
  parameter signed [15:0] coeffphase10_1 = 16'b1111111110101000; //sfix16_En17
  parameter signed [15:0] coeffphase10_2 = 16'b0000001001010101; //sfix16_En17
  parameter signed [15:0] coeffphase11_1 = 16'b1111111001000101; //sfix16_En17
  parameter signed [15:0] coeffphase11_2 = 16'b0000000110110000; //sfix16_En17
  parameter signed [15:0] coeffphase12_1 = 16'b1111110101111001; //sfix16_En17
  parameter signed [15:0] coeffphase12_2 = 16'b0000000001110100; //sfix16_En17
  parameter signed [15:0] coeffphase13_1 = 16'b1111110110011000; //sfix16_En17
  parameter signed [15:0] coeffphase13_2 = 16'b1111111100001000; //sfix16_En17
  parameter signed [15:0] coeffphase14_1 = 16'b1111111010100000; //sfix16_En17
  parameter signed [15:0] coeffphase14_2 = 16'b1111110010010110; //sfix16_En17
  parameter signed [15:0] coeffphase15_1 = 16'b0000000000110110; //sfix16_En17
  parameter signed [15:0] coeffphase15_2 = 16'b1101101110100100; //sfix16_En17
  parameter signed [15:0] coeffphase16_1 = 16'b0000000111000101; //sfix16_En17
  parameter signed [15:0] coeffphase16_2 = 16'b0000000110100000; //sfix16_En17
  parameter signed [15:0] coeffphase17_1 = 16'b0000001010111101; //sfix16_En17
  parameter signed [15:0] coeffphase17_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase18_1 = 16'b0000001010111011; //sfix16_En17
  parameter signed [15:0] coeffphase18_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase19_1 = 16'b0000000110101101; //sfix16_En17
  parameter signed [15:0] coeffphase19_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase20_1 = 16'b1111111111110110; //sfix16_En17
  parameter signed [15:0] coeffphase20_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase21_1 = 16'b1111111000101101; //sfix16_En17
  parameter signed [15:0] coeffphase21_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase22_1 = 16'b1111110100000000; //sfix16_En17
  parameter signed [15:0] coeffphase22_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase23_1 = 16'b1111110011100101; //sfix16_En17
  parameter signed [15:0] coeffphase23_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase24_1 = 16'b1111110111110101; //sfix16_En17
  parameter signed [15:0] coeffphase24_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase25_1 = 16'b1111111111010101; //sfix16_En17
  parameter signed [15:0] coeffphase25_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase26_1 = 16'b0000000111011100; //sfix16_En17
  parameter signed [15:0] coeffphase26_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase27_1 = 16'b0000001101001001; //sfix16_En17
  parameter signed [15:0] coeffphase27_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase28_1 = 16'b0000001110001101; //sfix16_En17
  parameter signed [15:0] coeffphase28_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase29_1 = 16'b0000001001111101; //sfix16_En17
  parameter signed [15:0] coeffphase29_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase30_1 = 16'b0000000001101111; //sfix16_En17
  parameter signed [15:0] coeffphase30_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase31_1 = 16'b1111111000011010; //sfix16_En17
  parameter signed [15:0] coeffphase31_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase32_1 = 16'b1111110001011110; //sfix16_En17
  parameter signed [15:0] coeffphase32_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase33_1 = 16'b1111101111100110; //sfix16_En17
  parameter signed [15:0] coeffphase33_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase34_1 = 16'b1111110011110101; //sfix16_En17
  parameter signed [15:0] coeffphase34_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase35_1 = 16'b1111111100111011; //sfix16_En17
  parameter signed [15:0] coeffphase35_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase36_1 = 16'b0000000111101110; //sfix16_En17
  parameter signed [15:0] coeffphase36_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase37_1 = 16'b0000010000010001; //sfix16_En17
  parameter signed [15:0] coeffphase37_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase38_1 = 16'b0000010011001100; //sfix16_En17
  parameter signed [15:0] coeffphase38_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase39_1 = 16'b0000001111000001; //sfix16_En17
  parameter signed [15:0] coeffphase39_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase40_1 = 16'b0000000100110111; //sfix16_En17
  parameter signed [15:0] coeffphase40_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase41_1 = 16'b1111111000001010; //sfix16_En17
  parameter signed [15:0] coeffphase41_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase42_1 = 16'b1111101101100010; //sfix16_En17
  parameter signed [15:0] coeffphase42_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase43_1 = 16'b1111101001001010; //sfix16_En17
  parameter signed [15:0] coeffphase43_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase44_1 = 16'b1111101101001011; //sfix16_En17
  parameter signed [15:0] coeffphase44_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase45_1 = 16'b1111111000101100; //sfix16_En17
  parameter signed [15:0] coeffphase45_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase46_1 = 16'b0000000111111100; //sfix16_En17
  parameter signed [15:0] coeffphase46_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase47_1 = 16'b0000010101011111; //sfix16_En17
  parameter signed [15:0] coeffphase47_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase48_1 = 16'b0000011011111101; //sfix16_En17
  parameter signed [15:0] coeffphase48_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase49_1 = 16'b0000011000010101; //sfix16_En17
  parameter signed [15:0] coeffphase49_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase50_1 = 16'b0000001010111101; //sfix16_En17
  parameter signed [15:0] coeffphase50_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase51_1 = 16'b1111110111111110; //sfix16_En17
  parameter signed [15:0] coeffphase51_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase52_1 = 16'b1111100110000100; //sfix16_En17
  parameter signed [15:0] coeffphase52_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase53_1 = 16'b1111011100001101; //sfix16_En17
  parameter signed [15:0] coeffphase53_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase54_1 = 16'b1111011111000101; //sfix16_En17
  parameter signed [15:0] coeffphase54_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase55_1 = 16'b1111101111001101; //sfix16_En17
  parameter signed [15:0] coeffphase55_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase56_1 = 16'b0000001000000101; //sfix16_En17
  parameter signed [15:0] coeffphase56_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase57_1 = 16'b0000100001011010; //sfix16_En17
  parameter signed [15:0] coeffphase57_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase58_1 = 16'b0000110001011011; //sfix16_En17
  parameter signed [15:0] coeffphase58_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase59_1 = 16'b0000110000011110; //sfix16_En17
  parameter signed [15:0] coeffphase59_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase60_1 = 16'b0000011011110101; //sfix16_En17
  parameter signed [15:0] coeffphase60_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase61_1 = 16'b1111110111111001; //sfix16_En17
  parameter signed [15:0] coeffphase61_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase62_1 = 16'b1111001111001000; //sfix16_En17
  parameter signed [15:0] coeffphase62_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase63_1 = 16'b1110110000011111; //sfix16_En17
  parameter signed [15:0] coeffphase63_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase64_1 = 16'b1110101010100110; //sfix16_En17
  parameter signed [15:0] coeffphase64_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase65_1 = 16'b1111000110111011; //sfix16_En17
  parameter signed [15:0] coeffphase65_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase66_1 = 16'b0000001000001100; //sfix16_En17
  parameter signed [15:0] coeffphase66_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase67_1 = 16'b0001100110010000; //sfix16_En17
  parameter signed [15:0] coeffphase67_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase68_1 = 16'b0011010001000011; //sfix16_En17
  parameter signed [15:0] coeffphase68_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase69_1 = 16'b0100110011010101; //sfix16_En17
  parameter signed [15:0] coeffphase69_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase70_1 = 16'b0101111000100011; //sfix16_En17
  parameter signed [15:0] coeffphase70_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase71_1 = 16'b0110010001011010; //sfix16_En17
  parameter signed [15:0] coeffphase71_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase72_1 = 16'b0101111000100011; //sfix16_En17
  parameter signed [15:0] coeffphase72_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase73_1 = 16'b0100110011010101; //sfix16_En17
  parameter signed [15:0] coeffphase73_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase74_1 = 16'b0011010001000011; //sfix16_En17
  parameter signed [15:0] coeffphase74_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase75_1 = 16'b0001100110010000; //sfix16_En17
  parameter signed [15:0] coeffphase75_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase76_1 = 16'b0000001000001100; //sfix16_En17
  parameter signed [15:0] coeffphase76_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase77_1 = 16'b1111000110111011; //sfix16_En17
  parameter signed [15:0] coeffphase77_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase78_1 = 16'b1110101010100110; //sfix16_En17
  parameter signed [15:0] coeffphase78_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase79_1 = 16'b1110110000011111; //sfix16_En17
  parameter signed [15:0] coeffphase79_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase80_1 = 16'b1111001111001000; //sfix16_En17
  parameter signed [15:0] coeffphase80_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase81_1 = 16'b1111110111111001; //sfix16_En17
  parameter signed [15:0] coeffphase81_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase82_1 = 16'b0000011011110101; //sfix16_En17
  parameter signed [15:0] coeffphase82_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase83_1 = 16'b0000110000011110; //sfix16_En17
  parameter signed [15:0] coeffphase83_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase84_1 = 16'b0000110001011011; //sfix16_En17
  parameter signed [15:0] coeffphase84_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase85_1 = 16'b0000100001011010; //sfix16_En17
  parameter signed [15:0] coeffphase85_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase86_1 = 16'b0000001000000101; //sfix16_En17
  parameter signed [15:0] coeffphase86_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase87_1 = 16'b1111101111001101; //sfix16_En17
  parameter signed [15:0] coeffphase87_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase88_1 = 16'b1111011111000101; //sfix16_En17
  parameter signed [15:0] coeffphase88_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase89_1 = 16'b1111011100001101; //sfix16_En17
  parameter signed [15:0] coeffphase89_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase90_1 = 16'b1111100110000100; //sfix16_En17
  parameter signed [15:0] coeffphase90_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase91_1 = 16'b1111110111111110; //sfix16_En17
  parameter signed [15:0] coeffphase91_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase92_1 = 16'b0000001010111101; //sfix16_En17
  parameter signed [15:0] coeffphase92_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase93_1 = 16'b0000011000010101; //sfix16_En17
  parameter signed [15:0] coeffphase93_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase94_1 = 16'b0000011011111101; //sfix16_En17
  parameter signed [15:0] coeffphase94_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase95_1 = 16'b0000010101011111; //sfix16_En17
  parameter signed [15:0] coeffphase95_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase96_1 = 16'b0000000111111100; //sfix16_En17
  parameter signed [15:0] coeffphase96_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase97_1 = 16'b1111111000101100; //sfix16_En17
  parameter signed [15:0] coeffphase97_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase98_1 = 16'b1111101101001011; //sfix16_En17
  parameter signed [15:0] coeffphase98_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase99_1 = 16'b1111101001001010; //sfix16_En17
  parameter signed [15:0] coeffphase99_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase100_1 = 16'b1111101101100010; //sfix16_En17
  parameter signed [15:0] coeffphase100_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase101_1 = 16'b1111111000001010; //sfix16_En17
  parameter signed [15:0] coeffphase101_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase102_1 = 16'b0000000100110111; //sfix16_En17
  parameter signed [15:0] coeffphase102_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase103_1 = 16'b0000001111000001; //sfix16_En17
  parameter signed [15:0] coeffphase103_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase104_1 = 16'b0000010011001100; //sfix16_En17
  parameter signed [15:0] coeffphase104_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase105_1 = 16'b0000010000010001; //sfix16_En17
  parameter signed [15:0] coeffphase105_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase106_1 = 16'b0000000111101110; //sfix16_En17
  parameter signed [15:0] coeffphase106_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase107_1 = 16'b1111111100111011; //sfix16_En17
  parameter signed [15:0] coeffphase107_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase108_1 = 16'b1111110011110101; //sfix16_En17
  parameter signed [15:0] coeffphase108_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase109_1 = 16'b1111101111100110; //sfix16_En17
  parameter signed [15:0] coeffphase109_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase110_1 = 16'b1111110001011110; //sfix16_En17
  parameter signed [15:0] coeffphase110_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase111_1 = 16'b1111111000011010; //sfix16_En17
  parameter signed [15:0] coeffphase111_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase112_1 = 16'b0000000001101111; //sfix16_En17
  parameter signed [15:0] coeffphase112_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase113_1 = 16'b0000001001111101; //sfix16_En17
  parameter signed [15:0] coeffphase113_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase114_1 = 16'b0000001110001101; //sfix16_En17
  parameter signed [15:0] coeffphase114_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase115_1 = 16'b0000001101001001; //sfix16_En17
  parameter signed [15:0] coeffphase115_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase116_1 = 16'b0000000111011100; //sfix16_En17
  parameter signed [15:0] coeffphase116_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase117_1 = 16'b1111111111010101; //sfix16_En17
  parameter signed [15:0] coeffphase117_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase118_1 = 16'b1111110111110101; //sfix16_En17
  parameter signed [15:0] coeffphase118_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase119_1 = 16'b1111110011100101; //sfix16_En17
  parameter signed [15:0] coeffphase119_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase120_1 = 16'b1111110100000000; //sfix16_En17
  parameter signed [15:0] coeffphase120_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase121_1 = 16'b1111111000101101; //sfix16_En17
  parameter signed [15:0] coeffphase121_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase122_1 = 16'b1111111111110110; //sfix16_En17
  parameter signed [15:0] coeffphase122_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase123_1 = 16'b0000000110101101; //sfix16_En17
  parameter signed [15:0] coeffphase123_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase124_1 = 16'b0000001010111011; //sfix16_En17
  parameter signed [15:0] coeffphase124_2 = 16'b0000000000000000; //sfix16_En17
  parameter signed [15:0] coeffphase125_1 = 16'b0000001010111101; //sfix16_En17
  parameter signed [15:0] coeffphase125_2 = 16'b0000000000000000; //sfix16_En17

  // Signals
  reg  [6:0] cur_count; // ufix7
  wire phase_4; // boolean
  wire phase_1; // boolean
  reg  ce_out_reg; // boolean
  reg  ce_in_reg; // boolean
  wire ce_out_phase; // boolean

  wire signed [15:0] product_mux; // sfix16_En17
  wire signed [15:0] product_mux_1; // sfix16_En17
  
  reg  signed [15:0] delay_pipeline_ch0 [0:1] ; // sfix16
  wire signed [31:0] product_ch0; // sfix32_En17
  wire signed [31:0] product_1_ch0; // sfix32_En17
  wire signed [32:0] product_1_cast_ch0; // sfix33_En17
  wire signed [32:0] fir_sum_ch0; // sfix33_En17
  wire signed [32:0] add_signext_ch0; // sfix33_En17
  wire signed [32:0] add_signext_1_ch0; // sfix33_En17
  wire signed [33:0] add_temp_ch0; // sfix34_En17
  reg  signed [32:0] output_register_ch0; // sfix33_En17

  reg  signed [15:0] delay_pipeline_ch1 [0:1] ; // sfix16
  wire signed [31:0] product_ch1; // sfix32_En17
  wire signed [31:0] product_1_ch1; // sfix32_En17
  wire signed [32:0] product_1_cast_ch1; // sfix33_En17
  wire signed [32:0] fir_sum_ch1; // sfix33_En17
  wire signed [32:0] add_signext_ch1; // sfix33_En17
  wire signed [32:0] add_signext_1_ch1; // sfix33_En17
  wire signed [33:0] add_temp_ch1; // sfix34_En17
  reg  signed [32:0] output_register_ch1; // sfix33_En17

  // Block Statements
  //   ------------------ CE Output Generation ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_output
      if (reset == 1'b1) begin
        cur_count <= 7'b0000000;
      end
      else begin
        if (clk_enable == 1'b1) begin
          if (cur_count == 7'b1111111) begin
            cur_count <= 7'b0000000;
          end
          else begin
            cur_count <= cur_count + 1;
          end
        end
      end
    end // ce_output

  assign  phase_4 = (((cur_count == 7'b0000000)  ||
                      (cur_count == 7'b0000100)  ||
                      (cur_count == 7'b0001000)  ||
                      (cur_count == 7'b0001100)  ||
                      (cur_count == 7'b0010000)  ||
                      (cur_count == 7'b0010100)  ||
                      (cur_count == 7'b0011000)  ||
                      (cur_count == 7'b0011100)  ||
                      (cur_count == 7'b0100000)  ||
                      (cur_count == 7'b0100100)  ||
                      (cur_count == 7'b0101000)  ||
                      (cur_count == 7'b0101100)  ||
                      (cur_count == 7'b0110000)  ||
                      (cur_count == 7'b0110100)  ||
                      (cur_count == 7'b0111000)  ||
                      (cur_count == 7'b0111100)  ||
                      (cur_count == 7'b1000000)  ||
                      (cur_count == 7'b1000100)  ||
                      (cur_count == 7'b1001000)  ||
                      (cur_count == 7'b1001100)  ||
                      (cur_count == 7'b1010000)  ||
                      (cur_count == 7'b1010100)  ||
                      (cur_count == 7'b1011000)  ||
                      (cur_count == 7'b1011100)  ||
                      (cur_count == 7'b1100000)  ||
                      (cur_count == 7'b1100100)  ||
                      (cur_count == 7'b1101000)  ||
                      (cur_count == 7'b1101100)  ||
                      (cur_count == 7'b1110000)  ||
                      (cur_count == 7'b1110100)  ||
                      (cur_count == 7'b1111000)  ||
                      (cur_count == 7'b1111100)) && clk_enable == 1'b1)? 1 : 0;

  assign  phase_1 = (((cur_count == 7'b0000001)  ||
                      (cur_count == 7'b0000010)  ||
                      (cur_count == 7'b0000011)  ||
                      (cur_count == 7'b0000100)  ||
                      (cur_count == 7'b0000101)  ||
                      (cur_count == 7'b0000110)  ||
                      (cur_count == 7'b0000111)  ||
                      (cur_count == 7'b0001000)  ||
                      (cur_count == 7'b0001001)  ||
                      (cur_count == 7'b0001010)  ||
                      (cur_count == 7'b0001011)  ||
                      (cur_count == 7'b0001100)  ||
                      (cur_count == 7'b0001101)  ||
                      (cur_count == 7'b0001110)  ||
                      (cur_count == 7'b0001111)  ||
                      (cur_count == 7'b0010000)  ||
                      (cur_count == 7'b0010001)  ||
                      (cur_count == 7'b0010010)  ||
                      (cur_count == 7'b0010011)  ||
                      (cur_count == 7'b0010100)  ||
                      (cur_count == 7'b0010101)  ||
                      (cur_count == 7'b0010110)  ||
                      (cur_count == 7'b0010111)  ||
                      (cur_count == 7'b0011000)  ||
                      (cur_count == 7'b0011001)  ||
                      (cur_count == 7'b0011010)  ||
                      (cur_count == 7'b0011011)  ||
                      (cur_count == 7'b0011100)  ||
                      (cur_count == 7'b0011101)  ||
                      (cur_count == 7'b0011110)  ||
                      (cur_count == 7'b0011111)  ||
                      (cur_count == 7'b0100000)  ||
                      (cur_count == 7'b0100001)  ||
                      (cur_count == 7'b0100010)  ||
                      (cur_count == 7'b0100011)  ||
                      (cur_count == 7'b0100100)  ||
                      (cur_count == 7'b0100101)  ||
                      (cur_count == 7'b0100110)  ||
                      (cur_count == 7'b0100111)  ||
                      (cur_count == 7'b0101000)  ||
                      (cur_count == 7'b0101001)  ||
                      (cur_count == 7'b0101010)  ||
                      (cur_count == 7'b0101011)  ||
                      (cur_count == 7'b0101101)  ||
                      (cur_count == 7'b0101110)  ||
                      (cur_count == 7'b0101111)  ||
                      (cur_count == 7'b0110000)  ||
                      (cur_count == 7'b0110001)  ||
                      (cur_count == 7'b0110010)  ||
                      (cur_count == 7'b0110011)  ||
                      (cur_count == 7'b0110100)  ||
                      (cur_count == 7'b0110101)  ||
                      (cur_count == 7'b0110110)  ||
                      (cur_count == 7'b0110111)  ||
                      (cur_count == 7'b0111000)  ||
                      (cur_count == 7'b0111001)  ||
                      (cur_count == 7'b0111010)  ||
                      (cur_count == 7'b0111011)  ||
                      (cur_count == 7'b0111100)  ||
                      (cur_count == 7'b0111101)  ||
                      (cur_count == 7'b0111110)  ||
                      (cur_count == 7'b0111111)  ||
                      (cur_count == 7'b1000000)  ||
                      (cur_count == 7'b1000001)  ||
                      (cur_count == 7'b1000010)  ||
                      (cur_count == 7'b1000011)  ||
                      (cur_count == 7'b1000100)  ||
                      (cur_count == 7'b1000101)  ||
                      (cur_count == 7'b1000110)  ||
                      (cur_count == 7'b1000111)  ||
                      (cur_count == 7'b1001000)  ||
                      (cur_count == 7'b1001001)  ||
                      (cur_count == 7'b1001010)  ||
                      (cur_count == 7'b1001011)  ||
                      (cur_count == 7'b1001100)  ||
                      (cur_count == 7'b1001101)  ||
                      (cur_count == 7'b1001110)  ||
                      (cur_count == 7'b1001111)  ||
                      (cur_count == 7'b1010000)  ||
                      (cur_count == 7'b1010001)  ||
                      (cur_count == 7'b1010010)  ||
                      (cur_count == 7'b1010011)  ||
                      (cur_count == 7'b1010100)  ||
                      (cur_count == 7'b1010101)  ||
                      (cur_count == 7'b1010110)  ||
                      (cur_count == 7'b1010111)  ||
                      (cur_count == 7'b1011001)  ||
                      (cur_count == 7'b1011010)  ||
                      (cur_count == 7'b1011011)  ||
                      (cur_count == 7'b1011100)  ||
                      (cur_count == 7'b1011101)  ||
                      (cur_count == 7'b1011110)  ||
                      (cur_count == 7'b1011111)  ||
                      (cur_count == 7'b1100000)  ||
                      (cur_count == 7'b1100001)  ||
                      (cur_count == 7'b1100010)  ||
                      (cur_count == 7'b1100011)  ||
                      (cur_count == 7'b1100100)  ||
                      (cur_count == 7'b1100101)  ||
                      (cur_count == 7'b1100110)  ||
                      (cur_count == 7'b1100111)  ||
                      (cur_count == 7'b1101000)  ||
                      (cur_count == 7'b1101001)  ||
                      (cur_count == 7'b1101010)  ||
                      (cur_count == 7'b1101011)  ||
                      (cur_count == 7'b1101100)  ||
                      (cur_count == 7'b1101101)  ||
                      (cur_count == 7'b1101110)  ||
                      (cur_count == 7'b1101111)  ||
                      (cur_count == 7'b1110000)  ||
                      (cur_count == 7'b1110001)  ||
                      (cur_count == 7'b1110010)  ||
                      (cur_count == 7'b1110011)  ||
                      (cur_count == 7'b1110100)  ||
                      (cur_count == 7'b1110101)  ||
                      (cur_count == 7'b1110110)  ||
                      (cur_count == 7'b1110111)  ||
                      (cur_count == 7'b1111000)  ||
                      (cur_count == 7'b1111001)  ||
                      (cur_count == 7'b1111010)  ||
                      (cur_count == 7'b1111011)  ||
                      (cur_count == 7'b1111100)  ||
                      (cur_count == 7'b1111101)  ||
                      (cur_count == 7'b1111110)  ||
                      (cur_count == 7'b1111111)) && clk_enable == 1'b1)? 1 : 0;

  //   ------------------ CE Output Register ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_out_delay_process
      if (reset == 1'b1) begin
        ce_out_reg <= 1'b0;
      end
      else begin
          ce_out_reg <= phase_1;
      end
    end // ce_out_delay_process

  //   ------------------ CE Input Register ------------------

  always @ (posedge clk or posedge reset)
    begin: ce_input_register
      if (reset == 1'b1) begin
        ce_in_reg <= 1'b0;
      end
      else begin
          ce_in_reg <= phase_4;
      end
    end // ce_input_register

  assign ce_out_phase =  ce_out_reg & clk_enable;

  //   ---------------- Delay Registers ----------------

  always @( posedge clk or posedge reset)
    begin: Delay_Pipeline_process
      if (reset == 1'b1) begin
        delay_pipeline_ch0[0] <= 0;
        delay_pipeline_ch0[1] <= 0;
        delay_pipeline_ch1[0] <= 0;
        delay_pipeline_ch1[1] <= 0;
      end
      else begin
        if (phase_4 == 1'b1) begin
          delay_pipeline_ch0[0] <= $signed({{1{filter_in_mux[15]}}, filter_in_mux[14:0]});
          delay_pipeline_ch0[1] <= delay_pipeline_ch0[0];
          //delay_pipeline_ch1[0] <= $signed(filter_in_mux[31:16]);
			 delay_pipeline_ch1[0] <= $signed({{1{filter_in_mux[31]}}, filter_in_mux[30:16]});
          delay_pipeline_ch1[1] <= delay_pipeline_ch1[0];
        end
      end
    end // Delay_Pipeline_process


  assign product_mux = (cur_count == 7'b0000001) ? coeffphase1_2 :
                      (cur_count == 7'b0000010) ? coeffphase33_2 :
                      (cur_count == 7'b0000011) ? coeffphase65_2 :
                      (cur_count == 7'b0000100) ? coeffphase97_2 :
                      (cur_count == 7'b0000101) ? coeffphase4_2 :
                      (cur_count == 7'b0000110) ? coeffphase36_2 :
                      (cur_count == 7'b0000111) ? coeffphase68_2 :
                      (cur_count == 7'b0001000) ? coeffphase100_2 :
                      (cur_count == 7'b0001001) ? coeffphase7_2 :
                      (cur_count == 7'b0001010) ? coeffphase39_2 :
                      (cur_count == 7'b0001011) ? coeffphase71_2 :
                      (cur_count == 7'b0001100) ? coeffphase103_2 :
                      (cur_count == 7'b0001101) ? coeffphase10_2 :
                      (cur_count == 7'b0001110) ? coeffphase42_2 :
                      (cur_count == 7'b0001111) ? coeffphase74_2 :
                      (cur_count == 7'b0010000) ? coeffphase106_2 :
                      (cur_count == 7'b0010001) ? coeffphase13_2 :
                      (cur_count == 7'b0010010) ? coeffphase45_2 :
                      (cur_count == 7'b0010011) ? coeffphase77_2 :
                      (cur_count == 7'b0010100) ? coeffphase109_2 :
                      (cur_count == 7'b0010101) ? coeffphase16_2 :
                      (cur_count == 7'b0010110) ? coeffphase48_2 :
                      (cur_count == 7'b0010111) ? coeffphase80_2 :
                      (cur_count == 7'b0011000) ? coeffphase112_2 :
                      (cur_count == 7'b0011001) ? coeffphase19_2 :
                      (cur_count == 7'b0011010) ? coeffphase51_2 :
                      (cur_count == 7'b0011011) ? coeffphase83_2 :
                      (cur_count == 7'b0011100) ? coeffphase115_2 :
                      (cur_count == 7'b0011101) ? coeffphase22_2 :
                      (cur_count == 7'b0011110) ? coeffphase54_2 :
                      (cur_count == 7'b0011111) ? coeffphase86_2 :
                      (cur_count == 7'b0100000) ? coeffphase118_2 :
                      (cur_count == 7'b0100001) ? coeffphase25_2 :
                      (cur_count == 7'b0100010) ? coeffphase57_2 :
                      (cur_count == 7'b0100011) ? coeffphase89_2 :
                      (cur_count == 7'b0100100) ? coeffphase121_2 :
                      (cur_count == 7'b0100101) ? coeffphase28_2 :
                      (cur_count == 7'b0100110) ? coeffphase60_2 :
                      (cur_count == 7'b0100111) ? coeffphase92_2 :
                      (cur_count == 7'b0101000) ? coeffphase124_2 :
                      (cur_count == 7'b0101001) ? coeffphase31_2 :
                      (cur_count == 7'b0101010) ? coeffphase63_2 :
                      (cur_count == 7'b0101011) ? coeffphase95_2 :
                      (cur_count == 7'b0101101) ? coeffphase2_2 :
                      (cur_count == 7'b0101110) ? coeffphase34_2 :
                      (cur_count == 7'b0101111) ? coeffphase66_2 :
                      (cur_count == 7'b0110000) ? coeffphase98_2 :
                      (cur_count == 7'b0110001) ? coeffphase5_2 :
                      (cur_count == 7'b0110010) ? coeffphase37_2 :
                      (cur_count == 7'b0110011) ? coeffphase69_2 :
                      (cur_count == 7'b0110100) ? coeffphase101_2 :
                      (cur_count == 7'b0110101) ? coeffphase8_2 :
                      (cur_count == 7'b0110110) ? coeffphase40_2 :
                      (cur_count == 7'b0110111) ? coeffphase72_2 :
                      (cur_count == 7'b0111000) ? coeffphase104_2 :
                      (cur_count == 7'b0111001) ? coeffphase11_2 :
                      (cur_count == 7'b0111010) ? coeffphase43_2 :
                      (cur_count == 7'b0111011) ? coeffphase75_2 :
                      (cur_count == 7'b0111100) ? coeffphase107_2 :
                      (cur_count == 7'b0111101) ? coeffphase14_2 :
                      (cur_count == 7'b0111110) ? coeffphase46_2 :
                      (cur_count == 7'b0111111) ? coeffphase78_2 :
                      (cur_count == 7'b1000000) ? coeffphase110_2 :
                      (cur_count == 7'b1000001) ? coeffphase17_2 :
                      (cur_count == 7'b1000010) ? coeffphase49_2 :
                      (cur_count == 7'b1000011) ? coeffphase81_2 :
                      (cur_count == 7'b1000100) ? coeffphase113_2 :
                      (cur_count == 7'b1000101) ? coeffphase20_2 :
                      (cur_count == 7'b1000110) ? coeffphase52_2 :
                      (cur_count == 7'b1000111) ? coeffphase84_2 :
                      (cur_count == 7'b1001000) ? coeffphase116_2 :
                      (cur_count == 7'b1001001) ? coeffphase23_2 :
                      (cur_count == 7'b1001010) ? coeffphase55_2 :
                      (cur_count == 7'b1001011) ? coeffphase87_2 :
                      (cur_count == 7'b1001100) ? coeffphase119_2 :
                      (cur_count == 7'b1001101) ? coeffphase26_2 :
                      (cur_count == 7'b1001110) ? coeffphase58_2 :
                      (cur_count == 7'b1001111) ? coeffphase90_2 :
                      (cur_count == 7'b1010000) ? coeffphase122_2 :
                      (cur_count == 7'b1010001) ? coeffphase29_2 :
                      (cur_count == 7'b1010010) ? coeffphase61_2 :
                      (cur_count == 7'b1010011) ? coeffphase93_2 :
                      (cur_count == 7'b1010100) ? coeffphase125_2 :
                      (cur_count == 7'b1010101) ? coeffphase32_2 :
                      (cur_count == 7'b1010110) ? coeffphase64_2 :
                      (cur_count == 7'b1010111) ? coeffphase96_2 :
                      (cur_count == 7'b1011001) ? coeffphase3_2 :
                      (cur_count == 7'b1011010) ? coeffphase35_2 :
                      (cur_count == 7'b1011011) ? coeffphase67_2 :
                      (cur_count == 7'b1011100) ? coeffphase99_2 :
                      (cur_count == 7'b1011101) ? coeffphase6_2 :
                      (cur_count == 7'b1011110) ? coeffphase38_2 :
                      (cur_count == 7'b1011111) ? coeffphase70_2 :
                      (cur_count == 7'b1100000) ? coeffphase102_2 :
                      (cur_count == 7'b1100001) ? coeffphase9_2 :
                      (cur_count == 7'b1100010) ? coeffphase41_2 :
                      (cur_count == 7'b1100011) ? coeffphase73_2 :
                      (cur_count == 7'b1100100) ? coeffphase105_2 :
                      (cur_count == 7'b1100101) ? coeffphase12_2 :
                      (cur_count == 7'b1100110) ? coeffphase44_2 :
                      (cur_count == 7'b1100111) ? coeffphase76_2 :
                      (cur_count == 7'b1101000) ? coeffphase108_2 :
                      (cur_count == 7'b1101001) ? coeffphase15_2 :
                      (cur_count == 7'b1101010) ? coeffphase47_2 :
                      (cur_count == 7'b1101011) ? coeffphase79_2 :
                      (cur_count == 7'b1101100) ? coeffphase111_2 :
                      (cur_count == 7'b1101101) ? coeffphase18_2 :
                      (cur_count == 7'b1101110) ? coeffphase50_2 :
                      (cur_count == 7'b1101111) ? coeffphase82_2 :
                      (cur_count == 7'b1110000) ? coeffphase114_2 :
                      (cur_count == 7'b1110001) ? coeffphase21_2 :
                      (cur_count == 7'b1110010) ? coeffphase53_2 :
                      (cur_count == 7'b1110011) ? coeffphase85_2 :
                      (cur_count == 7'b1110100) ? coeffphase117_2 :
                      (cur_count == 7'b1110101) ? coeffphase24_2 :
                      (cur_count == 7'b1110110) ? coeffphase56_2 :
                      (cur_count == 7'b1110111) ? coeffphase88_2 :
                      (cur_count == 7'b1111000) ? coeffphase120_2 :
                      (cur_count == 7'b1111001) ? coeffphase27_2 :
                      (cur_count == 7'b1111010) ? coeffphase59_2 :
                      (cur_count == 7'b1111011) ? coeffphase91_2 :
                      (cur_count == 7'b1111100) ? coeffphase123_2 :
                      (cur_count == 7'b1111101) ? coeffphase30_2 :
                      (cur_count == 7'b1111110) ? coeffphase62_2 :
                      coeffphase94_2;
  assign product_ch0 = delay_pipeline_ch0[1] * product_mux;
  assign product_ch1 = delay_pipeline_ch1[1] * product_mux;

  assign product_mux_1 = (cur_count == 7'b0000001) ? coeffphase1_1 :
                        (cur_count == 7'b0000010) ? coeffphase33_1 :
                        (cur_count == 7'b0000011) ? coeffphase65_1 :
                        (cur_count == 7'b0000100) ? coeffphase97_1 :
                        (cur_count == 7'b0000101) ? coeffphase4_1 :
                        (cur_count == 7'b0000110) ? coeffphase36_1 :
                        (cur_count == 7'b0000111) ? coeffphase68_1 :
                        (cur_count == 7'b0001000) ? coeffphase100_1 :
                        (cur_count == 7'b0001001) ? coeffphase7_1 :
                        (cur_count == 7'b0001010) ? coeffphase39_1 :
                        (cur_count == 7'b0001011) ? coeffphase71_1 :
                        (cur_count == 7'b0001100) ? coeffphase103_1 :
                        (cur_count == 7'b0001101) ? coeffphase10_1 :
                        (cur_count == 7'b0001110) ? coeffphase42_1 :
                        (cur_count == 7'b0001111) ? coeffphase74_1 :
                        (cur_count == 7'b0010000) ? coeffphase106_1 :
                        (cur_count == 7'b0010001) ? coeffphase13_1 :
                        (cur_count == 7'b0010010) ? coeffphase45_1 :
                        (cur_count == 7'b0010011) ? coeffphase77_1 :
                        (cur_count == 7'b0010100) ? coeffphase109_1 :
                        (cur_count == 7'b0010101) ? coeffphase16_1 :
                        (cur_count == 7'b0010110) ? coeffphase48_1 :
                        (cur_count == 7'b0010111) ? coeffphase80_1 :
                        (cur_count == 7'b0011000) ? coeffphase112_1 :
                        (cur_count == 7'b0011001) ? coeffphase19_1 :
                        (cur_count == 7'b0011010) ? coeffphase51_1 :
                        (cur_count == 7'b0011011) ? coeffphase83_1 :
                        (cur_count == 7'b0011100) ? coeffphase115_1 :
                        (cur_count == 7'b0011101) ? coeffphase22_1 :
                        (cur_count == 7'b0011110) ? coeffphase54_1 :
                        (cur_count == 7'b0011111) ? coeffphase86_1 :
                        (cur_count == 7'b0100000) ? coeffphase118_1 :
                        (cur_count == 7'b0100001) ? coeffphase25_1 :
                        (cur_count == 7'b0100010) ? coeffphase57_1 :
                        (cur_count == 7'b0100011) ? coeffphase89_1 :
                        (cur_count == 7'b0100100) ? coeffphase121_1 :
                        (cur_count == 7'b0100101) ? coeffphase28_1 :
                        (cur_count == 7'b0100110) ? coeffphase60_1 :
                        (cur_count == 7'b0100111) ? coeffphase92_1 :
                        (cur_count == 7'b0101000) ? coeffphase124_1 :
                        (cur_count == 7'b0101001) ? coeffphase31_1 :
                        (cur_count == 7'b0101010) ? coeffphase63_1 :
                        (cur_count == 7'b0101011) ? coeffphase95_1 :
                        (cur_count == 7'b0101101) ? coeffphase2_1 :
                        (cur_count == 7'b0101110) ? coeffphase34_1 :
                        (cur_count == 7'b0101111) ? coeffphase66_1 :
                        (cur_count == 7'b0110000) ? coeffphase98_1 :
                        (cur_count == 7'b0110001) ? coeffphase5_1 :
                        (cur_count == 7'b0110010) ? coeffphase37_1 :
                        (cur_count == 7'b0110011) ? coeffphase69_1 :
                        (cur_count == 7'b0110100) ? coeffphase101_1 :
                        (cur_count == 7'b0110101) ? coeffphase8_1 :
                        (cur_count == 7'b0110110) ? coeffphase40_1 :
                        (cur_count == 7'b0110111) ? coeffphase72_1 :
                        (cur_count == 7'b0111000) ? coeffphase104_1 :
                        (cur_count == 7'b0111001) ? coeffphase11_1 :
                        (cur_count == 7'b0111010) ? coeffphase43_1 :
                        (cur_count == 7'b0111011) ? coeffphase75_1 :
                        (cur_count == 7'b0111100) ? coeffphase107_1 :
                        (cur_count == 7'b0111101) ? coeffphase14_1 :
                        (cur_count == 7'b0111110) ? coeffphase46_1 :
                        (cur_count == 7'b0111111) ? coeffphase78_1 :
                        (cur_count == 7'b1000000) ? coeffphase110_1 :
                        (cur_count == 7'b1000001) ? coeffphase17_1 :
                        (cur_count == 7'b1000010) ? coeffphase49_1 :
                        (cur_count == 7'b1000011) ? coeffphase81_1 :
                        (cur_count == 7'b1000100) ? coeffphase113_1 :
                        (cur_count == 7'b1000101) ? coeffphase20_1 :
                        (cur_count == 7'b1000110) ? coeffphase52_1 :
                        (cur_count == 7'b1000111) ? coeffphase84_1 :
                        (cur_count == 7'b1001000) ? coeffphase116_1 :
                        (cur_count == 7'b1001001) ? coeffphase23_1 :
                        (cur_count == 7'b1001010) ? coeffphase55_1 :
                        (cur_count == 7'b1001011) ? coeffphase87_1 :
                        (cur_count == 7'b1001100) ? coeffphase119_1 :
                        (cur_count == 7'b1001101) ? coeffphase26_1 :
                        (cur_count == 7'b1001110) ? coeffphase58_1 :
                        (cur_count == 7'b1001111) ? coeffphase90_1 :
                        (cur_count == 7'b1010000) ? coeffphase122_1 :
                        (cur_count == 7'b1010001) ? coeffphase29_1 :
                        (cur_count == 7'b1010010) ? coeffphase61_1 :
                        (cur_count == 7'b1010011) ? coeffphase93_1 :
                        (cur_count == 7'b1010100) ? coeffphase125_1 :
                        (cur_count == 7'b1010101) ? coeffphase32_1 :
                        (cur_count == 7'b1010110) ? coeffphase64_1 :
                        (cur_count == 7'b1010111) ? coeffphase96_1 :
                        (cur_count == 7'b1011001) ? coeffphase3_1 :
                        (cur_count == 7'b1011010) ? coeffphase35_1 :
                        (cur_count == 7'b1011011) ? coeffphase67_1 :
                        (cur_count == 7'b1011100) ? coeffphase99_1 :
                        (cur_count == 7'b1011101) ? coeffphase6_1 :
                        (cur_count == 7'b1011110) ? coeffphase38_1 :
                        (cur_count == 7'b1011111) ? coeffphase70_1 :
                        (cur_count == 7'b1100000) ? coeffphase102_1 :
                        (cur_count == 7'b1100001) ? coeffphase9_1 :
                        (cur_count == 7'b1100010) ? coeffphase41_1 :
                        (cur_count == 7'b1100011) ? coeffphase73_1 :
                        (cur_count == 7'b1100100) ? coeffphase105_1 :
                        (cur_count == 7'b1100101) ? coeffphase12_1 :
                        (cur_count == 7'b1100110) ? coeffphase44_1 :
                        (cur_count == 7'b1100111) ? coeffphase76_1 :
                        (cur_count == 7'b1101000) ? coeffphase108_1 :
                        (cur_count == 7'b1101001) ? coeffphase15_1 :
                        (cur_count == 7'b1101010) ? coeffphase47_1 :
                        (cur_count == 7'b1101011) ? coeffphase79_1 :
                        (cur_count == 7'b1101100) ? coeffphase111_1 :
                        (cur_count == 7'b1101101) ? coeffphase18_1 :
                        (cur_count == 7'b1101110) ? coeffphase50_1 :
                        (cur_count == 7'b1101111) ? coeffphase82_1 :
                        (cur_count == 7'b1110000) ? coeffphase114_1 :
                        (cur_count == 7'b1110001) ? coeffphase21_1 :
                        (cur_count == 7'b1110010) ? coeffphase53_1 :
                        (cur_count == 7'b1110011) ? coeffphase85_1 :
                        (cur_count == 7'b1110100) ? coeffphase117_1 :
                        (cur_count == 7'b1110101) ? coeffphase24_1 :
                        (cur_count == 7'b1110110) ? coeffphase56_1 :
                        (cur_count == 7'b1110111) ? coeffphase88_1 :
                        (cur_count == 7'b1111000) ? coeffphase120_1 :
                        (cur_count == 7'b1111001) ? coeffphase27_1 :
                        (cur_count == 7'b1111010) ? coeffphase59_1 :
                        (cur_count == 7'b1111011) ? coeffphase91_1 :
                        (cur_count == 7'b1111100) ? coeffphase123_1 :
                        (cur_count == 7'b1111101) ? coeffphase30_1 :
                        (cur_count == 7'b1111110) ? coeffphase62_1 :
                        coeffphase94_1;
  assign product_1_ch0 = delay_pipeline_ch0[0] * product_mux_1;
  assign product_1_ch1 = delay_pipeline_ch1[0] * product_mux_1;

  assign product_1_cast_ch0 = $signed({{1{product_1_ch0[31]}}, product_1_ch0});
  assign product_1_cast_ch1 = $signed({{1{product_1_ch1[31]}}, product_1_ch1});

  assign add_signext_ch0 = product_1_cast_ch0;
  assign add_signext_ch1 = product_1_cast_ch1;
  assign add_signext_1_ch0 = $signed({{1{product_ch0[31]}}, product_ch0});
  assign add_signext_1_ch1 = $signed({{1{product_ch1[31]}}, product_ch1});
  assign add_temp_ch0 = add_signext_ch0 + add_signext_1_ch0;
  assign add_temp_ch1 = add_signext_ch1 + add_signext_1_ch1;
  assign fir_sum_ch0 = add_temp_ch0[32:0];
  assign fir_sum_ch1 = add_temp_ch1[32:0];

  always @ (posedge clk or posedge reset)
    begin: Output_Register_process
      if (reset == 1'b1) begin
        output_register_ch0 <= 0;
		  output_register_ch1 <= 0;
      end
      else begin
        if (phase_1 == 1'b1) begin
          output_register_ch0 <= fir_sum_ch0;
			 output_register_ch1 <= fir_sum_ch1;
        end
      end
    end // Output_Register_process

  // Assignment Statements
  assign ce_out = ce_out_phase;
  assign ce_in = ce_in_reg;
  assign filter_out = { output_register_ch1[32:17], output_register_ch0[32:17]};
endmodule  // firrc
